-- Apart from just dialogs, this script also includes functions for the right click menu and scroll bar.

dialog = {}

function dialog.draw()
	-- Now come the dialogs!
	if DIAwindowani < 0 then
		-- Window is opening
		-- Window contents
		setColorDIA(192,192,192,239)
		love.graphics.rectangle("fill", DIAx, DIAy+DIAwindowani, DIAwidth, DIAheight)
		-- Text
		setColorDIA(0,0,0,255)
		love.graphics.printf(DIAtext, DIAx+10, DIAy+DIAwindowani+10, DIAwidth-20, "left")
		
		-- Text boxes
		dialog.textboxes()
		
		-- Button, if enabled
		if DIAcanclose ~= 0 then
			if mousein(DIAx+DIAwidth-51, DIAy+DIAwindowani+DIAheight-26, DIAx+DIAwidth-1, DIAy+DIAwindowani+DIAheight-1) and (DIAbtn1glow < 15) then
				DIAbtn1glow = DIAbtn1glow + 1
			elseif DIAbtn1glow > 0 then
				DIAbtn1glow = DIAbtn1glow - 1
			end
			
			if DIAcanclose == 3 or DIAcanclose == 4 or DIAcanclose == 5 then
				if mousein(DIAx+DIAwidth-106, DIAy+DIAwindowani+DIAheight-26, DIAx+DIAwidth-56, DIAy+DIAwindowani+DIAheight-1) and (DIAbtn2glow < 15) then
					DIAbtn2glow = DIAbtn2glow + 1
				elseif DIAbtn2glow > 0 then
					DIAbtn2glow = DIAbtn2glow - 1
				end
			end
			
			if DIAcanclose == 5 then
				if mousein(DIAx+DIAwidth-156, DIAy+DIAwindowani+DIAheight-26, DIAx+DIAwidth-106, DIAy+DIAwindowani+DIAheight-1) and (DIAbtn3glow < 15) then
					DIAbtn3glow = DIAbtn3glow + 1
				elseif DIAbtn3glow > 0 then
					DIAbtn3glow = DIAbtn3glow - 1
				end
			end

			setColorDIA(64+(4*DIAbtn1glow),64+(4*DIAbtn1glow),64+(4*DIAbtn1glow),128)
			love.graphics.rectangle("fill", DIAx+DIAwidth-51, DIAy+DIAwindowani+DIAheight-26, 50, 25)
			setColorDIA(0,0,0,255)
			if DIAcanclose == 1 then
				love.graphics.printf("OK", DIAx+DIAwidth-51, DIAy+DIAwindowani+DIAheight-16, 50, "center")
			elseif DIAcanclose == 2 then
				love.graphics.printf("Quit", DIAx+DIAwidth-51, DIAy+DIAwindowani+DIAheight-16, 50, "center")
			elseif DIAcanclose == 3 then
				love.graphics.printf("No", DIAx+DIAwidth-51, DIAy+DIAwindowani+DIAheight-16, 50, "center")
			elseif DIAcanclose == 4 then
				love.graphics.printf("Cancel", DIAx+DIAwidth-51, DIAy+DIAwindowani+DIAheight-16, 50, "center")
			elseif DIAcanclose == 5 then
				love.graphics.printf("Apply", DIAx+DIAwidth-51, DIAy+DIAwindowani+DIAheight-16, 50, "center")
			end
			
			if DIAcanclose == 3 then
				setColorDIA(64+(4*DIAbtn2glow),64+(4*DIAbtn2glow),64+(4*DIAbtn2glow),128)
				love.graphics.rectangle("fill", DIAx+DIAwidth-106, DIAy+DIAwindowani+DIAheight-26, 50, 25)
				setColorDIA(0,0,0,255)
				love.graphics.printf("Yes", DIAx+DIAwidth-106, DIAy+DIAwindowani+DIAheight-16, 50, "center")
			elseif DIAcanclose == 4 then
				setColorDIA(64+(4*DIAbtn2glow),64+(4*DIAbtn2glow),64+(4*DIAbtn2glow),128)
				love.graphics.rectangle("fill", DIAx+DIAwidth-106, DIAy+DIAwindowani+DIAheight-26, 50, 25)
				setColorDIA(0,0,0,255)
				love.graphics.printf("OK", DIAx+DIAwidth-106, DIAy+DIAwindowani+DIAheight-16, 50, "center")
			elseif DIAcanclose == 5 then
				setColorDIA(64+(4*DIAbtn2glow),64+(4*DIAbtn2glow),64+(4*DIAbtn2glow),128)
				love.graphics.rectangle("fill", DIAx+DIAwidth-106, DIAy+DIAwindowani+DIAheight-26, 50, 25)
				setColorDIA(0,0,0,255)
				love.graphics.printf("Cancel", DIAx+DIAwidth-106, DIAy+DIAwindowani+DIAheight-16, 50, "center")
			end
			
			if DIAcanclose == 5 then
				setColorDIA(64+(4*DIAbtn3glow),64+(4*DIAbtn3glow),64+(4*DIAbtn3glow),128)
				love.graphics.rectangle("fill", DIAx+DIAwidth-161, DIAy+DIAwindowani+DIAheight-26, 50, 25)
				setColorDIA(0,0,0,255)
				love.graphics.printf("OK", DIAx+DIAwidth-161, DIAy+DIAwindowani+DIAheight-16, 50, "center")
			end
		end
		-- Window border
		setColorDIA(255,255,255,239)
		love.graphics.rectangle("line", DIAx, DIAy+DIAwindowani, DIAwidth, DIAheight)
		-- Bar, if enabled
		if DIAbar == 1 then
			setColorDIA(64,64,64,128)
			love.graphics.rectangle("fill", DIAx-1, DIAy+DIAwindowani-17, DIAwidth+2, 16)
			
			-- Also display the title text (if not empty). Shadow first
			setColorDIA(0,0,0,255)
			love.graphics.print(DIAbartext, DIAx-1+4+1, DIAy+DIAwindowani-17+6+1)
			setColorDIA(255,255,255,255)
			love.graphics.print(DIAbartext, DIAx-1+4, DIAy+DIAwindowani-17+6)
		end
		--DIAwindowani = DIAwindowani + 1
		DIAwindowani = math.min(DIAwindowani + (60/math.max(love.timer.getFPS(), 1)), 0)
	elseif DIAwindowani == 0 then
		-- Window is normal
		-- Window contents
		setColorDIA(192,192,192,239)
		love.graphics.rectangle("fill", DIAx, DIAy, DIAwidth, DIAheight)
		-- Text
		setColorDIA(0,0,0,255)
		love.graphics.printf(DIAtext, DIAx+10, DIAy+10, DIAwidth-20, "left")
		
		-- Text boxes
		dialog.textboxes()
		
		-- Button, if enabled
		if DIAcanclose ~= 0 then
			if mousein(DIAx+DIAwidth-51, DIAy+DIAwindowani+DIAheight-26, DIAx+DIAwidth-1, DIAy+DIAwindowani+DIAheight-1) and (DIAbtn1glow < 15) then
				DIAbtn1glow = DIAbtn1glow + 1
			elseif DIAbtn1glow > 0 then
				DIAbtn1glow = DIAbtn1glow - 1
			end
			
			if DIAcanclose == 3 or DIAcanclose == 4 or DIAcanclose == 5 then
				if mousein(DIAx+DIAwidth-106, DIAy+DIAheight-26, DIAx+DIAwidth-56, DIAy+DIAheight-1) and (DIAbtn2glow < 15) then
					DIAbtn2glow = DIAbtn2glow + 1
				elseif DIAbtn2glow > 0 then
					DIAbtn2glow = DIAbtn2glow - 1
				end
			end
			
			if DIAcanclose == 5 then
				if mousein(DIAx+DIAwidth-156, DIAy+DIAheight-26, DIAx+DIAwidth-106, DIAy+DIAheight-1) and (DIAbtn3glow < 15) then
					DIAbtn3glow = DIAbtn3glow + 1
				elseif DIAbtn3glow > 0 then
					DIAbtn3glow = DIAbtn3glow - 1
				end
			end
			
			setColorDIA(64+(4*DIAbtn1glow),64+(4*DIAbtn1glow),64+(4*DIAbtn1glow),128)
			love.graphics.rectangle("fill", DIAx+DIAwidth-51, DIAy+DIAheight-26, 50, 25)
			setColorDIA(0,0,0,255)
			if DIAcanclose == 1 then
				love.graphics.printf("OK", DIAx+DIAwidth-51, DIAy+DIAwindowani+DIAheight-16, 50, "center")
			elseif DIAcanclose == 2 then
				love.graphics.printf("Quit", DIAx+DIAwidth-51, DIAy+DIAwindowani+DIAheight-16, 50, "center")
			elseif DIAcanclose == 3 then
				love.graphics.printf("No", DIAx+DIAwidth-51, DIAy+DIAwindowani+DIAheight-16, 50, "center")
			elseif DIAcanclose == 4 then
				love.graphics.printf("Cancel", DIAx+DIAwidth-51, DIAy+DIAwindowani+DIAheight-16, 50, "center")
			elseif DIAcanclose == 5 then
				love.graphics.printf("Apply", DIAx+DIAwidth-51, DIAy+DIAwindowani+DIAheight-16, 50, "center")
			end
			
			if DIAcanclose == 3 then
				setColorDIA(64+(4*DIAbtn2glow),64+(4*DIAbtn2glow),64+(4*DIAbtn2glow),128)
				love.graphics.rectangle("fill", DIAx+DIAwidth-106, DIAy+DIAwindowani+DIAheight-26, 50, 25)
				setColorDIA(0,0,0,255)
				love.graphics.printf("Yes", DIAx+DIAwidth-106, DIAy+DIAwindowani+DIAheight-16, 50, "center")
			elseif DIAcanclose == 4 then
				setColorDIA(64+(4*DIAbtn2glow),64+(4*DIAbtn2glow),64+(4*DIAbtn2glow),128)
				love.graphics.rectangle("fill", DIAx+DIAwidth-106, DIAy+DIAwindowani+DIAheight-26, 50, 25)
				setColorDIA(0,0,0,255)
				love.graphics.printf("OK", DIAx+DIAwidth-106, DIAy+DIAwindowani+DIAheight-16, 50, "center")
			elseif DIAcanclose == 5 then
				setColorDIA(64+(4*DIAbtn2glow),64+(4*DIAbtn2glow),64+(4*DIAbtn2glow),128)
				love.graphics.rectangle("fill", DIAx+DIAwidth-106, DIAy+DIAwindowani+DIAheight-26, 50, 25)
				setColorDIA(0,0,0,255)
				love.graphics.printf("Cancel", DIAx+DIAwidth-106, DIAy+DIAwindowani+DIAheight-16, 50, "center")
			end
			
			if DIAcanclose == 5 then
				setColorDIA(64+(4*DIAbtn3glow),64+(4*DIAbtn3glow),64+(4*DIAbtn3glow),128)
				love.graphics.rectangle("fill", DIAx+DIAwidth-161, DIAy+DIAwindowani+DIAheight-26, 50, 25)
				setColorDIA(0,0,0,255)
				love.graphics.printf("OK", DIAx+DIAwidth-161, DIAy+DIAwindowani+DIAheight-16, 50, "center")
			end
		end
		-- Window border
		setColorDIA(255,255,255,239)
		love.graphics.rectangle("line", DIAx, DIAy, DIAwidth, DIAheight)
		-- Bar, if enabled
		if DIAbar == 1 then
			setColorDIA(64,64,64,128)
			love.graphics.rectangle("fill", DIAx-1, DIAy-17, DIAwidth+2, 16)
			
			-- Also display the title text (if not empty). Shadow first
			setColorDIA(0,0,0,255)
			love.graphics.print(DIAbartext, DIAx-1+4+1, DIAy-17+6+1)
			setColorDIA(255,255,255,255)
			love.graphics.print(DIAbartext, DIAx-1+4, DIAy-17+6)
		end
	elseif (DIAwindowani > 0) and (DIAwindowani < 16) then
		-- Window is closing
		-- Window contents
		setColorDIA(192,192,192,239)
		love.graphics.rectangle("fill", DIAx, DIAy+DIAwindowani, DIAwidth, DIAheight)
		-- Text
		setColorDIA(0,0,0,255)
		love.graphics.printf(DIAtext, DIAx+10, DIAy+DIAwindowani+10, DIAwidth-20, "left")
		
		-- Text boxes
		dialog.textboxes()
		
		-- Button, if enabled
		if DIAcanclose ~= 0 then
			if mousein(DIAx+DIAwidth-51, DIAy+DIAwindowani+DIAheight-26, DIAx+DIAwidth-1, DIAy+DIAwindowani+DIAheight-1) and (DIAbtn1glow < 15) then
				DIAbtn1glow = DIAbtn1glow + 1
			elseif DIAbtn1glow > 0 then
				DIAbtn1glow = DIAbtn1glow - 1
			end
			
			if DIAcanclose == 3 or DIAcanclose == 4 or DIAcanclose == 5 then
				if mousein(DIAx+DIAwidth-106, DIAy+DIAwindowani+DIAheight-26, DIAx+DIAwidth-56, DIAy+DIAwindowani+DIAheight-1) and (DIAbtn2glow < 15) then
					DIAbtn2glow = DIAbtn2glow + 1
				elseif DIAbtn2glow > 0 then
					DIAbtn2glow = DIAbtn2glow - 1
				end
			end
			
			if DIAcanclose == 5 then
				if mousein(DIAx+DIAwidth-156, DIAy+DIAwindowani+DIAheight-26, DIAx+DIAwidth-106, DIAy+DIAwindowani+DIAheight-1) and (DIAbtn3glow < 15) then
					DIAbtn3glow = DIAbtn3glow + 1
				elseif DIAbtn3glow > 0 then
					DIAbtn3glow = DIAbtn3glow - 1
				end
			end
			
			setColorDIA(64+(4*DIAbtn1glow),64+(4*DIAbtn1glow),64+(4*DIAbtn1glow),128)
			love.graphics.rectangle("fill", DIAx+DIAwidth-51, DIAy+DIAwindowani+DIAheight-26, 50, 25)
			setColorDIA(0,0,0,255)
			if DIAcanclose == 1 then
				love.graphics.printf("OK", DIAx+DIAwidth-51, DIAy+DIAwindowani+DIAheight-16, 50, "center")
			elseif DIAcanclose == 2 then
				love.graphics.printf("Quit", DIAx+DIAwidth-51, DIAy+DIAwindowani+DIAheight-16, 50, "center")
			elseif DIAcanclose == 3 then
				love.graphics.printf("No", DIAx+DIAwidth-51, DIAy+DIAwindowani+DIAheight-16, 50, "center")
			elseif DIAcanclose == 4 then
				love.graphics.printf("Cancel", DIAx+DIAwidth-51, DIAy+DIAwindowani+DIAheight-16, 50, "center")
			elseif DIAcanclose == 5 then
				love.graphics.printf("Apply", DIAx+DIAwidth-51, DIAy+DIAwindowani+DIAheight-16, 50, "center")
			end
			
			if DIAcanclose == 3 then
				setColorDIA(64+(4*DIAbtn2glow),64+(4*DIAbtn2glow),64+(4*DIAbtn2glow),128)
				love.graphics.rectangle("fill", DIAx+DIAwidth-106, DIAy+DIAwindowani+DIAheight-26, 50, 25)
				setColorDIA(0,0,0,255)
				love.graphics.printf("Yes", DIAx+DIAwidth-106, DIAy+DIAwindowani+DIAheight-16, 50, "center")
			elseif DIAcanclose == 4 then
				setColorDIA(64+(4*DIAbtn2glow),64+(4*DIAbtn2glow),64+(4*DIAbtn2glow),128)
				love.graphics.rectangle("fill", DIAx+DIAwidth-106, DIAy+DIAwindowani+DIAheight-26, 50, 25)
				setColorDIA(0,0,0,255)
				love.graphics.printf("OK", DIAx+DIAwidth-106, DIAy+DIAwindowani+DIAheight-16, 50, "center")
			elseif DIAcanclose == 5 then
				setColorDIA(64+(4*DIAbtn2glow),64+(4*DIAbtn2glow),64+(4*DIAbtn2glow),128)
				love.graphics.rectangle("fill", DIAx+DIAwidth-106, DIAy+DIAwindowani+DIAheight-26, 50, 25)
				setColorDIA(0,0,0,255)
				love.graphics.printf("Cancel", DIAx+DIAwidth-106, DIAy+DIAwindowani+DIAheight-16, 50, "center")
			end
			
			if DIAcanclose == 5 then
				setColorDIA(64+(4*DIAbtn3glow),64+(4*DIAbtn3glow),64+(4*DIAbtn3glow),128)
				love.graphics.rectangle("fill", DIAx+DIAwidth-161, DIAy+DIAwindowani+DIAheight-26, 50, 25)
				setColorDIA(0,0,0,255)
				love.graphics.printf("OK", DIAx+DIAwidth-161, DIAy+DIAwindowani+DIAheight-16, 50, "center")
			end
		end
		-- Window border
		setColorDIA(255,255,255,239)
		love.graphics.rectangle("line", DIAx, DIAy+DIAwindowani, DIAwidth, DIAheight)
		-- Bar, if enabled
		if DIAbar == 1 then
			setColorDIA(64,64,64,128)
			love.graphics.rectangle("fill", DIAx-1, DIAy+DIAwindowani-17, DIAwidth+2, 16)
			
			-- Also display the title text (if not empty). Shadow first
			setColorDIA(0,0,0,255)
			love.graphics.print(DIAbartext, DIAx-1+4+1, DIAy+DIAwindowani-17+6+1)
			setColorDIA(255,255,255,255)
			love.graphics.print(DIAbartext, DIAx-1+4, DIAy+DIAwindowani-17+6)
		end
		--DIAwindowani = DIAwindowani + 1
		DIAwindowani = math.min(DIAwindowani + (60/math.max(love.timer.getFPS(), 1)), 16)
	-- else windowani == 16, window is gone
	elseif DIAwindowani == 16 then
		-- No dialog.
		if DIAquitting == 1 then
			love.timer.sleep(0.1)
			love.event.quit()
		end
	end
end

function dialog.textboxes()
	if DIAquestionid == 2 then
		-- Entity properties
		hoverdiatext(DIAx+10+16 +24, DIAy+DIAwindowani+10+24, 300, 8, multiinput[1], 1, currentmultiinput == 1)
		hoverdiatext(DIAx+10+16 +24, DIAy+DIAwindowani+10+24+8, 300, 8, multiinput[2], 2, currentmultiinput == 2)
		hoverdiatext(DIAx+10+16 +24, DIAy+DIAwindowani+10+24+8+8, 300, 8, multiinput[3], 3, currentmultiinput == 3)
		hoverdiatext(DIAx+10+16+8 +16, DIAy+DIAwindowani+10+24+8+8+8, 300, 8, multiinput[4], 4, currentmultiinput == 4)
		hoverdiatext(DIAx+10+16+8 +16, DIAy+DIAwindowani+10+24+8+8+8+8, 300, 8, multiinput[5], 5, currentmultiinput == 5)
		hoverdiatext(DIAx+10+16+8 +16, DIAy+DIAwindowani+10+24+8+8+8+8+8, 300, 8, multiinput[6], 6, currentmultiinput == 6)
		hoverdiatext(DIAx+10+16+8 +16, DIAy+DIAwindowani+10+24+8+8+8+8+8+8, 300, 8, multiinput[7], 7, currentmultiinput == 7)
		hoverdiatext(DIAx+10+16+8 +16, DIAy+DIAwindowani+10+24+8+8+8+8+8+8+8, 300, 8, multiinput[8], 8, currentmultiinput == 8)
		hoverdiatext(DIAx+10+16+8 +16, DIAy+DIAwindowani+10+24+8+8+8+8+8+8+8+8, 300, 8, multiinput[9], 9, currentmultiinput == 9)
		hoverdiatext(DIAx+10+16+24, DIAy+DIAwindowani+10+24+8+8+8+8+8+8+8+8+8, 300, 8, multiinput[10], 10, currentmultiinput == 10)
	elseif DIAquestionid == 5 then
		-- Level properties
		hoverdiatext(DIAx+10+(8*8), DIAy+DIAwindowani+10, 20*8, 8, multiinput[1], 1, currentmultiinput == 1)
		hoverdiatext(DIAx+10+(8*8), DIAy+DIAwindowani+10+(1*8), 37*8, 8, multiinput[2], 2, currentmultiinput == 2)
		hoverdiatext(DIAx+10+(8*8), DIAy+DIAwindowani+10+(2*8), 40*8, 8, multiinput[3], 3, currentmultiinput == 3)
		hoverdiatext(DIAx+10+(8*8), DIAy+DIAwindowani+10+(4*8), 40*8, 8, multiinput[4], 4, currentmultiinput == 4)
		hoverdiatext(DIAx+10+(8*8), DIAy+DIAwindowani+10+(5*8), 40*8, 8, multiinput[5], 5, currentmultiinput == 5)
		hoverdiatext(DIAx+10+(8*8), DIAy+DIAwindowani+10+(6*8), 40*8, 8, multiinput[6], 6, currentmultiinput == 6)
		hoverdiatext(DIAx+10+(5*8), DIAy+DIAwindowani+10+(8*8), 3*8, 8, multiinput[7], 7, currentmultiinput == 7)
		hoverdiatext(DIAx+10+(9*8), DIAy+DIAwindowani+10+(8*8), 3*8, 8, multiinput[8], 8, currentmultiinput == 8)
		hoverdiatext(DIAx+10+(6*8), DIAy+DIAwindowani+10+(10*8), 3*8, 8, multiinput[9], 9, currentmultiinput == 9)
	elseif DIAquestionid == 9 or DIAquestionid == 11 or DIAquestionid == 12 or DIAquestionid == 13 then
		-- Create new script or note
		hoverdiatext(DIAx+10+(0*8), DIAy+DIAwindowani+10+(1*8), 20*8, 8, multiinput[1], 1, currentmultiinput == 1)
	elseif DIAquestionid == 10 then
		-- Save level
		hoverdiatext(DIAx+10+(0*8), DIAy+DIAwindowani+10+(1*8), 20*8, 8, multiinput[1], 1, currentmultiinput == 1)
	end
end

--[[
function dialog.keypressed()
	if (DIAwindowani ~= 16) and (DIAcanclose == 1) and (key == "return") then
		dialog.push()
		DIAreturn = 1
	elseif (DIAwindowani ~= 16) and (DIAcanclose == 2) and (key == "return") then
		dialog.push()
		DIAreturn = 1
		DIAquitting = 1
	end
end
]]

function dialog.update()
	if (DIAcanclose == 5 and DIAreturn == 1) --[[ apply ]] or (DIAwindowani == 16 and DIAquestionid ~= 0) then
		if (DIAquestionid == 1) then -- State 9 test
			-- Do something
			-- if DIAreturn == 1 then
			youdidanswer = "You answered: " .. DIAreturn
		elseif (DIAquestionid == 2) then
			-- Save entity properties
			if DIAreturn == 2 or DIAreturn == 3 then -- cancel/ok
				stopinput()
			end
			
			if DIAreturn == 1 or DIAreturn == 3 then -- apply or ok
				-- entdetails[3] is still the ID of this entity
				entitydata[tonumber(entdetails[3])].x = anythingbutnil0(tonumber(multiinput[1]))
				entitydata[tonumber(entdetails[3])].y = anythingbutnil0(tonumber(multiinput[2]))
				entitydata[tonumber(entdetails[3])].t = anythingbutnil0(tonumber(multiinput[3]))
				entitydata[tonumber(entdetails[3])].p1 = anythingbutnil0(tonumber(multiinput[4]))
				entitydata[tonumber(entdetails[3])].p2 = anythingbutnil0(tonumber(multiinput[5]))
				entitydata[tonumber(entdetails[3])].p3 = anythingbutnil0(tonumber(multiinput[6]))
				entitydata[tonumber(entdetails[3])].p4 = anythingbutnil0(tonumber(multiinput[7]))
				entitydata[tonumber(entdetails[3])].p5 = anythingbutnil0(tonumber(multiinput[8]))
				entitydata[tonumber(entdetails[3])].p6 = anythingbutnil0(tonumber(multiinput[9]))
				entitydata[tonumber(entdetails[3])].data = multiinput[10]
			end
		elseif (DIAquestionid == 3) then
			-- load a level or not
			if DIAreturn == 2 then -- yes
				tostate(6)
			end
		elseif (DIAquestionid == 4) and (DIAreturn == 2) then
			-- Add a 21st trinket
			cons("Trinket: " .. atx .. " " .. aty)
			
			table.insert(entitydata,
				{
				x = 40*roomx + atx,
				y = 30*roomy + aty,
				t = 9,
				p1 = 0, p2 = 0, p3 = 0, p4 = 0, p5 = 320, p6 = 240,
				data = ""
				})
				
			count.trinkets = count.trinkets + 1
			count.entities = count.entities + 1
		elseif (DIAquestionid == 5) then
			stopinput()
			if DIAreturn == 2 then
				-- Level properties
				metadata.Title = multiinput[1]
				metadata.Creator = multiinput[2]
				metadata.website = multiinput[3]
				metadata.Desc1 = multiinput[4]
				metadata.Desc2 = multiinput[5]
				metadata.Desc3 = multiinput[6]
				--if ( (tonumber(multiinput[7]) > 20) or (tonumber(multiinput[8]) > 20) ) and ( (tonumber(multiinput[7]) < metadata.mapwidth) or (tonumber(multiinput[8]) < metadata.mapheight) ) then
					-- On one side you're making the map size too large and on the other you're making it smaller than it is...
					
				--v elseif
				if (tonumber(multiinput[7]) > 20) or (tonumber(multiinput[8]) > 20) then
					-- Ok hold on a second. Do you really want that?
					if s.allowlimitbypass then
						dialog.new("The maximum size of a level is 20 by 20.\n\nExceeding this limit will cause glitches and inconsistencies when loading the level in VVVVVV. It is strongly recommended not to do this, unless you are only testing. Are you sure you want to bypass the limit?", "", 1, 3, 6)
						replacedialog = true
					else
						dialog.new("The maximum size of a level is 20 by 20.\n\nThe room size will be changed to " .. math.min(20, tonumber(multiinput[7])) .. " by " .. math.min(20, tonumber(multiinput[8])) .. " instead.", "", 1, 1, 0)
						metadata.mapwidth = math.min(20, tonumber(multiinput[7]))
						metadata.mapheight = math.min(20, tonumber(multiinput[8]))
						addrooms(metadata.mapwidth, metadata.mapheight)
						roomx = math.min(roomx, metadata.mapwidth-1); roomy = math.min(roomy, metadata.mapheight-1)
					end
				--elseif (tonumber(multiinput[7]) < metadata.mapwidth) or (tonumber(multiinput[8]) < metadata.mapheight) then
					-- We're making the map smaller
					--dialog.new("Are you sure you wish to make the map smaller?
				else
					-- Just do it
					metadata.mapwidth = math.min(20, tonumber(multiinput[7]))
					metadata.mapheight = math.min(20, tonumber(multiinput[8]))
					addrooms(metadata.mapwidth, metadata.mapheight)
					roomx = math.min(roomx, metadata.mapwidth-1); roomy = math.min(roomy, metadata.mapheight-1)
				end
				metadata.levmusic = multiinput[9]
			end
		elseif (DIAquestionid == 6) and (DIAreturn == 2) then
			-- Yes, I do want to change the level size to this. If I set it to lower than the existing size I might lose rooms - or if I bypass the 20x20 limit this level will become nuclear.
			metadata.mapwidth = tonumber(multiinput[7])
			metadata.mapheight = tonumber(multiinput[8])
			addrooms(metadata.mapwidth, metadata.mapheight)
			roomx = math.min(roomx, metadata.mapwidth-1); roomy = math.min(roomy, metadata.mapheight-1)
		elseif (DIAquestionid == 7) and (DIAreturn == 2) then
			-- Yes, create a new blank map, I'll lose any unsaved content
			-- Make a dialog for options right away later
			success, metadata, roomdata, entitydata, levelmetadata, scripts, count, scriptnames, vedmetadata = createblanklevel(5, 5)
			editingmap = "untitled\n"
			tostate(1)
		elseif (DIAquestionid == 8) and (DIAreturn == 2) then
			-- Yes, quit. I'll lose any unsaved content.
			bypassdialog = true
			love.event.quit()
		elseif (DIAquestionid == 9 or DIAquestionid == 11) then
			stopinput()
			if DIAreturn == 2 then
				-- Add a script with this name.
				
				if DIAquestionid == 11 then
					-- We're currently already editing a script so save that before jumping to a new one!
					scriptlines[editingline] = input .. input_r
					scripts[scriptname] = scriptlines
				end
				
				if scripts[multiinput[1]] == nil then
					scripts[multiinput[1]] = {""}
					table.insert(scriptnames, multiinput[1])
					
					scriptname = multiinput[1]
					scriptlines = {""}
					tostate(3)
				else
					dialog.new("Script " .. multiinput[1] .. " already exists!", "(Dav, don't forget to make this bump the script)", 1, 1, 0) -- !!!!!
					replacedialog = true
					
					scriptname = multiinput[1]
					scriptlines = scripts[multiinput[1]]
					--bumpscript(multiinput[1])
					tostate(3)
				end
			elseif DIAquestionid == 11 then
				-- We were already editing a script so re-enable input for that!
				takinginput = true
			end
		elseif (DIAquestionid == 10) then
			stopinput()
			if DIAreturn == 2 then
				-- Save the level with this name.
				
				savedsuccess, savederror = savelevel(multiinput[1] .. ".vvvvvv", metadata, roomdata, entitydata, levelmetadata, scripts, vedmetadata)
				editingmap = multiinput[1]
				
				if not savedsuccess then
					-- Why not :c
					dialog.new(L.SAVENOSUCCESS .. anythingbutnil(savederror), "", 1, 1, 0)
					replacedialog = true
				end
			end
		-- DIAQUESTIONID 11 IS HANDLED ABOVE (ALMOST EQUAL TO 9)
		elseif (DIAquestionid == 12) then
			stopinput()
			if DIAreturn == 2 then
				-- Add a note with this name.
				stopinput()
				
				-- We're currently already editing a script so save that before jumping to a new one!
				--scripts[scriptname] = scriptlines .
				
								-- v by reference anyways
				table.insert(helppages, {subj = multiinput[1], imgs = {}, cont = [[
	]] .. multiinput[1] .. [[\wh#

	Content]]})

				helparticle = #helppages
				helpeditingline = 3
				takinginput = true
				helparticlecontent = explode("\n", helppages[#helppages].cont)
				input = anythingbutnil(helparticlecontent[3])
			end
		elseif (DIAquestionid == 13) then
			stopinput()
			if DIAreturn == 2 then
				-- Rename this note
				
				helppages[helparticle].subj = multiinput[1]
				
				--[[
				if helpeditingline ~= 0 then
					takinginput = true
				end
				]]
			end
		elseif (DIAquestionid == 14) and (DIAreturn == 2) then
			-- Yes, delete this note
			table.remove(helppages, helparticle)
			if helppages[helparticle] == nil then
				helparticle = helparticle - 1
			end
			
			-- Go to the new article (removing this line will cause the deleted article to be left on the screen, along with its buttons, but not the button in the left menu for it)
			helparticlecontent = explode("\n", helppages[helparticle].cont)
		end
		
		-- The answer to the question has been handled now. Or has it?
		if replacedialog == nil then
			if not (DIAcanclose == 5 and DIAreturn == 1) then
				DIAquestionid = 0
				multiinput = {}
			end
			--replacedialog = nil
		end
		replacedialog = nil
		DIAreturn = 0
	end
	
	if DIAmovingwindow == 1 then
		DIAx = DIAmovedfromwx + (love.mouse.getX()-DIAmovedfrommx)
		DIAy = DIAmovedfromwy + (love.mouse.getY()-DIAmovedfrommy)
	end
end

--[[
function dialog.mousepressed()
	if (DIAwindowani ~= 16) and (DIAbar == 1) and (mouseb == "l") and (mousex >= DIAx) and (mousex <= DIAx+DIAwidth) and (mousey >= DIAy-17) and (mousey <= DIAy) then
		DIAmovingwindow = 1
		DIAmovedfromwx = DIAx
		DIAmovedfromwy = DIAy
		DIAmovedfrommx = mousex
		DIAmovedfrommy = mousey
	end
	
	if DIAwindowani ~= 16 then
		if (DIAcanclose == 1) and mousein(DIAx+DIAwidth-51, DIAy+DIAwindowani+DIAheight-26, DIAx+DIAwidth-1, DIAy+DIAwindowani+DIAheight-1) then
			dialog.push()
			DIAreturn = 1
		elseif (DIAcanclose == 2) and mousein(DIAx+DIAwidth-51, DIAy+DIAwindowani+DIAheight-26, DIAx+DIAwidth-1, DIAy+DIAwindowani+DIAheight-1) then
			dialog.push()
			DIAreturn = 1
			DIAquitting = 1
		elseif (DIAcanclose == 3) and mousein(DIAx+DIAwidth-51, DIAy+DIAwindowani+DIAheight-26, DIAx+DIAwidth-1, DIAy+DIAwindowani+DIAheight-1) then
			dialog.push()
			DIAreturn = 1
		elseif (DIAcanclose == 3) and mousein(DIAx+DIAwidth-106, DIAy+DIAwindowani+DIAheight-26, DIAx+DIAwidth-56, DIAy+DIAwindowani+DIAheight-1) then
			dialog.push()
			DIAreturn = 2
		end
		
		return
	end
end
]]

function dialog.new(message, title, showbar, canclose, questionid)
	dialog.init()
	DIAbartext = title
	DIAtext = message
	DIAbar = showbar
	DIAcanclose = canclose
	if s.dialoganimations then
		DIAwindowani = -15
	else
		DIAwindowani = 0
	end
	
	if (questionid ~= nil) then
		DIAquestionid = questionid
	else
		DIAquestionid = 0
	end
	
	DIAreturn = 0
end

function dialog.push()
	if s.dialoganimations then
		DIAwindowani = DIAwindowani + 1
	else
		DIAwindowani = 16
	end
end

function setColorDIA(rood, groen, blauw, alfa)
	if math.floor(DIAwindowani) < 0 then
		love.graphics.setColor(rood,groen,blauw,((math.floor(DIAwindowani)+15)/15)*alfa)
	elseif math.floor(DIAwindowani) == 0 then
		love.graphics.setColor(rood,groen,blauw,alfa)
	elseif (math.floor(DIAwindowani) > 0) and (math.floor(DIAwindowani) < 16) then
		love.graphics.setColor(rood,groen,blauw,((15-math.floor(DIAwindowani))/15)*alfa)
	end
end

function dialog.init()
	-- DIAx = 200
	-- DIAy = 225
	DIAx = (love.graphics.getWidth()-400)/2
	DIAy = (love.graphics.getHeight()-150)/2
	DIAwidth = 400
	DIAheight = 150
	DIAmovingwindow = 0
	DIAmovedfromwx = 100
	DIAmovedfromwy = 100
	DIAmovedfrommx = 0
	DIAmovedfrommy = 0
	DIAquitting = 0
	DIAwindowani = 16
	DIAbtn1glow = 0
	DIAbtn2glow = 0
	DIAbtn3glow = 0
	DIAquestionid = 0
	
	DIAbar = 1
	DIAcanclose = 1 -- Can be closed. This is actually the button type, 0 is none - dialog can't be closed, 1 is OK, 2 is Quit, 3 is yes or no.
	
	DIAreturn = 0 -- Button pressed, which could be used afterwards.
	
	DIAbartext = "UNDEFINED"
	DIAtext = "UNDEFINED"
end

-- And here some stuff for the right click menu
rightclickmenu = {}
function rightclickmenu.create(items, menuid)
	RCMactive = true
	RCMx = love.mouse.getX()
	RCMy = math.min(love.mouse.getY(), love.graphics.getHeight()-(#items*16))
	RCMitems = items
	RCMid = menuid -- can be anything, really
	RCMreturn = ""
end

function rightclickmenu.draw()
	if RCMactive == true then
		for k,v in pairs(RCMitems) do
			if v:sub(1, 1) == "#" then
				love.graphics.setColor(128,128,128,192)
				love.graphics.rectangle("fill", RCMx, (k-1)*16+RCMy, 150, 16)
				love.graphics.setColor(192,192,192,255)
				love.graphics.print(v:sub(2, -1), RCMx+1, (k-1)*16+RCMy+6)
				love.graphics.setColor(255,255,255,255)
			else
				hoverrectangle(128,128,128,192, RCMx, (k-1)*16+RCMy, 150, 16, true)
				love.graphics.print(v, RCMx+1, (k-1)*16+RCMy+6)
				
				if love.mouse.isDown("l") and mouseon(RCMx, (k-1)*16+RCMy, 150, 16) then
					RCMreturn = v
				end
			end
		end
		
		if love.mouse.isDown("l") then
			RCMactive = false
		end
	end
end

-- Scroll bars!
function scrollbar(x, y, height, scrollableheight, peronetage)
	-- Returns nil if untouched, returns scroll value if moved
	
	love.graphics.setColor(96,96,96,96)
	love.graphics.rectangle("fill", x, y, 16, height)
	
	if scrollableheight > height then
		-- Display an actual scrollable thing
		-- BUTTONheight: (height/scrollableheight)*height
		-- BUTTONy: (height-BUTTONheight)*peronetage
		local buttonheight = (height/scrollableheight)*height
		
		love.graphics.setColor(192,192,192,255)
		love.graphics.rectangle("fill", x, y+(height-buttonheight)*peronetage, 16, buttonheight)
	end
	
	love.graphics.setColor(255,255,255,255)
end